variables:
  TMP_IMAGE: $CI_REGISTRY_IMAGE/tmp:$CI_COMMIT_SHA

stages:
- test
- build-image
- release-version
- release-major

include:
- template: Security/Dependency-Scanning.gitlab-ci.yml

.ruby:
  image: ruby:2.7.4
  before_script:
    - bundle config set path vendor/
    - bundle install

check_ruby:
  stage: test
  script:
    - bundle exec ruby -wc $(find . -name Dangerfile)
  extends:
    - .ruby

unit_tests:
  stage: test
  script:
    - bundle exec rake test
  extends:
    - .ruby

danger_review:
  stage: test
  variables:
    DANGER_ROOT: $CI_PROJECT_DIR
    BUNDLE_WITHOUT: development
  script:
    - mv analyzers/Dangerfile Dangerfile
    - bundle exec danger --fail-on-errors=true
  extends:
   - .ruby

build tmp image:
  image: docker:20.10
  stage: build-image
  services:
    - docker:20.10-dind
  script:
    - docker info
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build --build-arg GO_VERSION -t $TMP_IMAGE .
    - docker push $TMP_IMAGE

.docker_tag:
  image: docker:20.10
  stage: release-version
  services:
    - docker:20.10-dind
  script:
    - docker info
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - export SOURCE_IMAGE=$TMP_IMAGE
    - export TARGET_IMAGE=$CI_REGISTRY_IMAGE:${IMAGE_TAG:-$CI_JOB_NAME}
    - docker pull $SOURCE_IMAGE
    - docker tag $SOURCE_IMAGE $TARGET_IMAGE
    - docker push $TARGET_IMAGE

tag branch:
  extends: .docker_tag
  variables:
    # CAUTION: by preferring `SLUG` over `NAME` we can properly handle non-alphanumeric
    # characters, but this may limit our tags to 63chars or raise potential conflicts.
    IMAGE_TAG: $CI_COMMIT_REF_SLUG
  rules:
    - if: $CI_DEFAULT_BRANCH == $CI_COMMIT_REF_NAME
      when: never
    - if: $CI_COMMIT_BRANCH

tag edge:
  extends: .docker_tag
  variables:
    IMAGE_TAG: edge
  rules:
    - if: $CI_DEFAULT_BRANCH == $CI_COMMIT_REF_NAME

tag version:
  extends: .docker_tag
  before_script:
    # Drop build tag
    - export IMAGE_TAG=${CI_COMMIT_TAG/+*/}
  rules:
    - if: $CI_COMMIT_TAG

.release:
  extends: .docker_tag
  stage: release-major
  rules:
    - if: $CI_COMMIT_TAG

major:
  extends: .release
  before_script:
    # Drop build tag
    - export RELEASE=${CI_COMMIT_TAG/+*/}
    # Cut off two dots and whatever follows it
    - export IMAGE_TAG=${RELEASE%.*.*}

minor:
  extends: .release
  before_script:
    # Drop build tag
    - export RELEASE=${CI_COMMIT_TAG/+*/}
    # Cut off last dot and whatever follows it
    - export IMAGE_TAG=${RELEASE%.*}

latest:
  extends: .release
